/*
**    TP 5ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef PERLIN_HPP
#define PERLIN_HPP

namespace cpe
{

class v2;
class v3;
class v4;

class perlin
{
public:
    /** \brief return perlin noise in 1D */
    static double noise(const double x,int octave,double persistency);
    /** \brief return perlin noise in 2D */
    static double noise(const v2& x,int octave,double persistency);
    /** \brief return perlin noise in 3D */
    static double noise(const v3& x,int octave,double persistency);
    /** \brief return perlin noise in 4D */
    static double noise(const v4& x,int octave,double persistency);

private:
};
}

#endif
